//============================================================================
// Name        : testing.cpp
// Author      : 
// Version     :
// Copyright   : 
// Description : Hello World in C++, Ansi-style
//============================================================================

#include <iostream>
#include <vector>
#include <sys/time.h>
#include <string>
#include <algorithm>
#include <iterator>
using namespace std;

#include "../tnl/tnlVector.h"
#include "tnlVectorSam.h"

using namespace std;
using namespace TNL;


static bool sg_initialized = false;
static U32 sg_uSecsOffset = 0;

unsigned long getMicroSeconds()
{
   // TODO: What happens when crossing a day boundary?
   //
   timeval t;

   if (sg_initialized == false) {
      sg_initialized = true;

      ::gettimeofday(&t, NULL);
      sg_uSecsOffset = t.tv_usec;
   }

   ::gettimeofday(&t, NULL);

   unsigned long uSecs  = t.tv_usec - sg_uSecsOffset;

   return uSecs;
}


void empty() {
   SAM::Vector<int> vecOther;

   for (int i = 0; i < 10000; i++)
      vecOther.push_back(i*i);

   unsigned long time = getMicroSeconds();

   vecOther.empty();

   cout << "SAM::Vector: " << getMicroSeconds() - time << endl;

   // ==================================================
   Vector<int> vecTnl;

   time = getMicroSeconds();

   for (int i = 0; i < 10000; i++)
      vecTnl.push_back(i*i);

   time = getMicroSeconds();

   vecTnl.empty();

   cout << "tnlVector:    " << getMicroSeconds() - time << endl;

   // ==================================================
   vector<int> vec;

   for (int i = 0; i < 10000; i++)
      vec.push_back(i*i);

   time = getMicroSeconds();

   vec.empty();

   cout << "std::vector:  " << getMicroSeconds() - time << endl; time = getMicroSeconds();
}

void erase(unsigned int index) {
   SAM::Vector<int> vecOther;

   for (int i = 0; i < 10000; i++)
      vecOther.push_back(i*i);

   unsigned long time = getMicroSeconds();

   vecOther.erase(index);

   cout << "SAM::Vector: " << getMicroSeconds() - time << endl;

   // ==================================================
   Vector<int> vecTnl;

   time = getMicroSeconds();

   for (int i = 0; i < 10000; i++)
      vecTnl.push_back(i*i);

   time = getMicroSeconds();

   vecTnl.erase(index);

   cout << "tnlVector:    " << getMicroSeconds() - time << endl;

   // ==================================================
   vector<int> vec;

   for (int i = 0; i < 10000; i++)
      vec.push_back(i*i);

   time = getMicroSeconds();

   vec.erase(vec.begin() + index);

   cout << "std::vector:  " << getMicroSeconds() - time << endl; time = getMicroSeconds();
}

void insert(unsigned int index) {
   SAM::Vector<int> vecOther;

   for (int i = 0; i < 10000; i++)
      vecOther.push_back(i*i);

   unsigned long time = getMicroSeconds();

   vecOther.insert(index);

   cout << "SAM::Vector: " << getMicroSeconds() - time << endl;

   // ==================================================
   Vector<int> vecTnl;

   time = getMicroSeconds();

   for (int i = 0; i < 10000; i++)
      vecTnl.push_back(i*i);

   time = getMicroSeconds();

   vecTnl.insert(index);

   cout << "tnlVector:    " << getMicroSeconds() - time << endl;

   // ==================================================
   vector<int> vec;

   for (int i = 0; i < 10000; i++)
      vec.push_back(i*i);

   time = getMicroSeconds();

   vec.insert(vec.begin() + index, int());

   cout << "std::vector:  " << getMicroSeconds() - time << endl; time = getMicroSeconds();
}



void pushBack(int count) {
   SAM::Vector<int> vecOther;

   unsigned long time = getMicroSeconds();

   for (int i = 0; i < count; i++)
      vecOther.push_back(i);

   cout << "SAM::Vector: " << getMicroSeconds() - time << endl;

   // ==================================================
   Vector<int> vecTnl;

   time = getMicroSeconds();

   for (int i = 0; i < count; i++)
      vecTnl.push_back(i);

   cout << "tnlVector:    " << getMicroSeconds() - time << endl;

   // ==================================================
   vector<int> vec;

   time = getMicroSeconds();

   for (int i = 0; i < count; i++)
      vec.push_back(i);

   cout << "std::vector:  " << getMicroSeconds() - time << endl; time = getMicroSeconds();

}

void pushFront(int count) {
   SAM::Vector<int> vecOther;

   unsigned long long time = getMicroSeconds();

   for (int i = 0; i < count; i++)
      vecOther.push_front(i);

   cout << "SAM::Vector: " << getMicroSeconds() - time << endl;

   // ==================================================
   Vector<int> vecTnl;

   time = getMicroSeconds();

   for (int i = 0; i < count; i++)
      vecTnl.push_front(i);

   cout << "tnlVector:    " << getMicroSeconds() - time << endl;

   // ==================================================
   vector<int> vec;

   time = getMicroSeconds();

   for (int i = 0; i < count; i++)
      vec.insert(vec.begin(), i);

   cout << "std::vector:  " << getMicroSeconds() - time << endl; time = getMicroSeconds();

}

void popBack(int count) {
   SAM::Vector<int> vecOther;

   for (int i = 0; i < count; i++)
      vecOther.push_back(i*i);

   unsigned long time = getMicroSeconds();

   for (int i = 0; i < count; i++)
      int j = vecOther.pop_back();

   cout << "SAM::Vector: " << getMicroSeconds() - time << endl;

   // ==================================================
   Vector<int> vecTnl;

   for (int i = 0; i < count; i++)
      vecTnl.push_back(i*i);

   time = getMicroSeconds();

   for (int i = 0; i < count; i++)
      int j = vecTnl.pop_back();

   cout << "tnlVector:    " << getMicroSeconds() - time << endl;

   // ==================================================
   vector<int> vec;

   for (int i = 0; i < count; i++)
      vec.push_back(i*i);

   time = getMicroSeconds();

   for (int i = 0; i < count; i++) {
      int j = vec.back();
      vec.pop_back();
   }

   cout << "std::vector:  " << getMicroSeconds() - time << endl; time = getMicroSeconds();

}



void popFront(int count) {
   SAM::Vector<int> vecOther;

   for (int i = 0; i < count; i++)
      vecOther.push_back(i*i);

   unsigned long time = getMicroSeconds();

   for (int i = 0; i < count; i++)
      int j = vecOther.pop_front();

   cout << "SAM::Vector: " << getMicroSeconds() - time << endl;

   // ==================================================
   Vector<int> vecTnl;

   for (int i = 0; i < count; i++)
      vecTnl.push_back(i*i);

   time = getMicroSeconds();

   for (int i = 0; i < count; i++)
      int j = vecTnl.pop_front();

   cout << "tnlVector:    " << getMicroSeconds() - time << endl;

   // ==================================================
   vector<int> vec;

   for (int i = 0; i < count; i++)
      vec.push_back(i*i);

   time = getMicroSeconds();

   for (int i = 0; i < count; i++) {
      int j = vec[0];
      vec.erase(vec.begin());
   }

   cout << "std::vector:  " << getMicroSeconds() - time << endl; time = getMicroSeconds();

}


vector<string> splitString(const string& s, const string& delim, const bool keep_empty = true) {
    vector<string> result;

    if (delim.empty()) {
        result.push_back(s);
        return result;
    }

    string::const_iterator substart = s.begin(), subend;
    while (true) {
        subend = search(substart, s.end(), delim.begin(), delim.end());
        string temp(substart, subend);
        if (keep_empty || !temp.empty()) {
            result.push_back(temp);
        }
        if (subend == s.end()) {
            break;
        }
        substart = subend + delim.size();
    }
    return result;
}


void testSplitString() {

   const vector<string> words = splitString("So, close, no, matter, how, far", ", ");
   copy(words.begin(), words.end(), ostream_iterator<string>(cout, "\n"));
}


void testArrayToVectorSpeed() {
   int size = 1000000;

   int array[size];

   for(int i = 0; i < size; i++)
      array[i] = i * (i%5);

   unsigned long time = getMicroSeconds();

   vector<int> inputVector;
   for(int i = 0; i < size; i++)
      inputVector.push_back(array[i]);

   cout << "old way: " << getMicroSeconds() - time << endl;

   // ====================
   time = getMicroSeconds();

   vector<int> inputVector2(array, array + sizeof(array) / sizeof(array[0]) );

   cout << "new way: " << getMicroSeconds() - time << endl;
}


int main() {
   cout << "push_back(10000)" << endl << "------------" << endl;
   pushBack(10000);

   cout << endl << "pop_back(10000)" << endl << "------------" << endl;
   popBack(10000);

   cout << endl << "push_front(10000)" << endl << "------------" << endl;
   pushFront(10000);

   cout << endl << "pop_front(10000)" << endl << "------------" << endl;
   popFront(10000);

   cout << endl << "erase(0)" << endl << "------------" << endl;
   erase(0);

   cout << endl << "erase(4000)" << endl << "------------" << endl;
   erase(4000);

   cout << endl << "erase(9000)" << endl << "------------" << endl;
   erase(9000);

   cout << endl << "insert(0)" << endl << "------------" << endl;
   insert(0);

   cout << endl << "insert(4000)" << endl << "------------" << endl;
   insert(4000);

   cout << endl << "insert(9000)" << endl << "------------" << endl;
   insert(9000);

//   testSplitString();
//
//   testArrayToVectorSpeed();

   return 0;
}
